#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h> // included for pid_t
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>

void usage()
{
	printf( "Usage:\n"
		"timeout <time> [-s <signal>] cmd...\n");
}

void child(int i) {
}

int main(int argc, char *argv[])
{
	int j = 2;
	int sec;
	int r;
	pid_t pid;
	if (argc < 3) {
		usage();
		exit(-1);
	}
	sec = atoi(argv[1]);
	while (argv[j][0] == '-') {
		if (j >= argc) {
			usage();
			exit(-1);
		}
		if (argv[j][1] == 's') j ++;
		j ++;
	}
	signal(SIGCHLD, &child);
	pid = fork();
	if (pid == -1) {
		fprintf(stderr, "fail to create a child process!\n");
		exit(-1);
	}
	if (pid == 0) {
		execvp(argv[j], argv + j);
		fprintf(stderr, "fail to execute the command!\n");
		exit(-1);
	}
	sleep(sec); 
	kill(pid, 9);
	wait(&r);
	return r;
}
